/**
 * srvoa - soa infrastructure for node js
 *
 * @copyright   Copyright (c) 2015, Alrik Zachert
 * @license     https://gitlab.com/a-z/node-srvoa/blob/master/LICENSE BSD-2-Clause
 */

"use strict";

/**
 * Abstract class that defines the srvoa service interface.
 */

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Service = (function () {
  /**
   * The local reference to the service manager instance.
   *
   * @property serviceManager {ServiceManager}
   */

  /**
   * Create a new service instance.
   *
   * @constructor
   * @param {ServiceManager} [serviceManager] - The service manager instance.
   */

  function Service(serviceManager) {
    _classCallCheck(this, Service);

    this.serviceManager = serviceManager || null;
  }

  /**
   * Returns the service manager instance.
   *
   * @return {ServiceManager}
   */

  _createClass(Service, [{
    key: "getServiceManager",
    value: function getServiceManager() {
      return this.serviceManager;
    }

    /**
     * Sets the service manager instance.
     *
     * @param   {ServiceManager} serviceManager
     * @return  {Service}
     */
  }, {
    key: "setServiceManager",
    value: function setServiceManager(serviceManager) {
      this.serviceManager = serviceManager;

      return this;
    }

    /**
     * Configures the service.
     *
     * @param   {Object} [config]
     * @return  {Service}
     */
  }, {
    key: "configure",
    value: function configure(config) {
      return this;
    }

    /**
     * Bootstrap the service logic.
     *
     * @return  {Service}
     */
  }, {
    key: "bootstrap",
    value: function bootstrap() {
      return this;
    }

    /**
     * Launch the service logic.
     *
     * @return  {Service}
     */
  }, {
    key: "launch",
    value: function launch() {
      return this;
    }
  }]);

  return Service;
})();

module.exports = Service;